Index: devicestate.c
===================================================================
--- devicestate.c	(revision 43901)
+++ devicestate.c	(working copy)
@@ -97,9 +97,19 @@
 /*! \brief Find devicestate as text message for output */
 const char *devstate2str(int devstate) 
 {
+	int elements;
+
+	elements = (sizeof(devstatestring) /  sizeof(devstatestring[0]));
+
+	if (devstate > elements || devstate < 0) {
+		ast_log(LOG_WARNING,"Invalid device state returning unknown.");
+		return devstatestring[0];
+	}
+	
 	return devstatestring[devstate];
 }
 
+
 /*! \brief Find out if device is active in a call or not 
 	\note find channels with the device's name in it
 	This function is only used for channels that does not implement 
